// Hippo text-mode interface implementation.

#include "hippo.h"

interface_text::interface_text(songlist *newsl) : interface(newsl) {
	pl = new playlist(newsl);
	newsl->select_all(pl);
}

interface_text::~interface_text() {
	delete pl;
}

void interface_text::main() {
	string cmdline;
	bool isc = false;
	pl->set_continuous(isc);
	
	do {
		cout << "hippo>" << flush;
		cin >> cmdline;

		switch (cmdline[0]) {
			case 'q':
				// do nothing
				break;
			case 'p':
				pl->play_previous();
				break;
			case 'n':
				pl->play_next();
				break;
			case 's':
				pl->stop();
				break;
			case 'r':
				pl->shuffle();
				break;
			case 'c':
				pl->set_continuous(isc = !isc);
				break;
			case '/':
				sl->select_match(pl, cmdline.substr(1));
				break;
			case 'a':
				sl->select_all(pl);
				break;
			case 'l':
				for(unsigned int i=0; i<pl->size(); i++) cout << pl->get_song(i).name << endl;
				break;
			case 'o':
				switch(cmdline[1]) {
					case 'n':
						pl->sort(playlist::by_name);
						break;
					case 'f':
						pl->sort(playlist::by_filename);
						break;
					default:
						cout << "unknown sort method" << endl;
						break;
				}
				break;
			case '?':
				cout << "Quit Prev Next Stop Random Continuous /search All List sOrt[Name Filename]" << endl;
				break;
			default:
				cout << "unknown command: " << cmdline << endl;
				break;
		}
	} while (cmdline[0] != 'q');
	pl->stop();
}

void interface_text::song_changed(int index) {
	cout << "new song: " << pl->get_song(index).name << endl;
}
